package cz.upol.foolang.ast;

import java.util.Set;
import java.util.stream.Collectors;

import cz.upol.foolang.types.Type;

public class FieldDeclaration extends Node {

	private final String name;
	private final Set<Modifier> modifiers;
	private final Type type;

	public FieldDeclaration(String name, Set<Modifier> modifiers, Type type) {
		super();
		this.name = name;
		this.modifiers = modifiers;
		this.type = type;
	}
	
	@Override
	public String toString() {
		String mods = modifiers.stream().map(m -> m.toString()).collect(Collectors.joining(" "));
		return String.format("%s %s %s", mods, type, name);
	}

}
