package cz.upol.foolang.ast;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import cz.upol.foolang.types.Type;

public class MethodDeclaration extends Node {

	private final String name;
	private final Set<Modifier> modifiers;
	private final List<Argument> arguments;
	private final Type returnType;

	public MethodDeclaration(String name, Set<Modifier> modifiers, Type returnType, List<Argument> arguments, Node code) {
		super(code);
		this.name = name;
		this.modifiers = modifiers;
		this.arguments = arguments;
		this.returnType = returnType;
	}
	
	@Override 
	public String toString() {
		String mods = modifiers.stream().map(m -> m.toString()).collect(Collectors.joining(" "));
		String args = arguments.stream().map(a -> a.toString()).collect(Collectors.joining(", "));
		
		return String.format("%s %s %s(%s)", mods, returnType, name, args);
	}
	
	
	
}
