package cz.upol.foolang.ast;

import cz.upol.foolang.types.Type;

/**
 * Deklarace promenne.
 * 
 * Pro jednoduchost predpokladame, ze deklarace je prikaz
 * a promennou nelze soucasne deklarovat a inicializovat.
 */
public class VariableDeclaration extends Node {

	private final String name;
	private final Type type;

	public VariableDeclaration(String name, Type type) {
		super();
		this.name = name;
		this.type = type;
	}
	
	@Override
	public String toString() {
		return String.format("%s %s", type, name);
	}

}
